#!/bin/bash
# Copyright 2008-2011 Matus Chochlik. Distributed under the Boost
# Software License, Version 1.0. (See accompanying file
# LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# This script updates the //build/common/ext_deps.cache file
# which is used by several other build-system tools
#
source $(dirname $0)/_get_parts.sh
input_dirs="$(for part in ${parts}; do echo src/${part}/example; done) devel"
header_paths="include src"
#
exec > build/common/ext_deps.cache
# print the copyright and license notice to the output
source $(dirname $0)/_make_disclaimer.sh
echo "#"
echo "# This file contains a list of external dependencies for every"
echo "# C++ source file that gets built."
echo "#"
#
hdr_to_ext_deps_sed='
s|^wx/.*\.h$|wxwidgets-cxxflags wxwidgets-libs|p;
s|^libpq-fe.h$|headers-libpq lib-pq|p;
s|^soci-postgresql\.h$|headers-soci lib-soci_core lib-soci_postgresql lib-pq|p;
s|^soci.*\.h$|headers-soci lib-soci_core|p;
s|^boost/filesystem.*\.hpp$|headers-boost lib-boost_filesystem lib-boost_system|p;
s|^boost/.*\.hpp$|headers-boost|p;
s|^rapidxml.hpp$|headers-rapidxml|p;
s|^dlfcn.h$|lib-dl|p;
';
#
for input_dir in ${input_dirs}
do
	find ${input_dir}/ -type f -name '*.cpp' |
	sort |
	while read source_file
	do
		echo -n "${source_file}:"
		echo ${source_file} |
		$(dirname $0)/_get_includes.sh ${header_paths} |
		sed -n "${hdr_to_ext_deps_sed}" |
		tr ' ' '\n' | sort | uniq | xargs echo
	done
done
