#!/bin/bash
# Copyright 2008-2010 Matus Chochlik. Distributed under the Boost
# Software License, Version 1.0. (See accompanying file
# LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# print the copyright and license notice to the output
source $(dirname $0)/_make_disclaimer.sh
#
# go through the dirs passed as arguments
for dirname in $*
do
	find ${dirname} -type f -name '*.po' |
	while read po_file
	do
		pattern="\(.*\)\.\([a-z]\{2,3\}_[A-Z]\{2,3\}\)\.po"
		replace="out/$(dirname ${po_file})/locale/\2/LC_MESSAGES/\1.mo"
		mo_file=$(echo $(basename ${po_file}) | sed "s|${pattern}|${replace}|")
		echo "${mo_file}: ${po_file} out/.dir_dummy"
		echo -e '\t@mkdir -p '$(dirname ${mo_file})
		echo -e '\tmsgfmt -c -o $@ $<'
		echo
	done
	echo -n "${dirname}_locale:" | sed 's|[/ ]|_|g'
	find ${dirname} -type f -name '*.po' |
	while read po_file
	do
		pattern="\(.*\)\.\([a-z]\{2,3\}_[A-Z]\{2,3\}\)\.po"
		replace="out/$(dirname ${po_file})/locale/\2/LC_MESSAGES/\1.mo"
		echo $(basename ${po_file}) | sed "s|${pattern}|${replace}|"
	done |
	sort |
	sed 's|\(.*\)|\\\\\\\n\\\t\1|' |
	xargs echo -e ""
done
