#!/bin/bash
# Copyright 2008-2011 Matus Chochlik. Distributed under the Boost
# Software License, Version 1.0. (See accompanying file
# LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# print the copyright and license notice to the output
source $(dirname $0)/_make_disclaimer.sh
#
#
ext_deps_to_cxxflags_sed='
s|\<wxwidgets-cxxflags\>|$(shell wx-config --cxxflags)|p;
s|\<headers-libpq\>|-I$(shell pg_config --includedir)|p;
';
#
ext_deps_to_ldflags_sed='
s|\<wxwidgets-libs\>|$(shell wx-config --libs)|p;
s|\<lib-\([-a-z0-9_.]\+\)\>|-l\1|p;
';
#
while read input_dir
do
find ${input_dir}/ -type f -name '*.cpp' |
sort |
while read source_file
do
	# print the rule target and the prereqisite source file
	echo "out/${source_file%.cpp}.o: \\"
	echo -e "\t${source_file} \\"
	echo -e "\tout/$(dirname ${source_file})/.dir_dummy \\"
	echo -e "\tout/.dir_dummy"
	# print the compiler command and its compile and link flags
	echo -e  '\t$(CXX) $(MIRROR_CXXFLAGS) \\'
	# print the special cxxflags for this specific source file
	grep -e "^${source_file}:" < build/common/ext_deps.cache |
	cut -d ':' -f2- | tr ' ' '\n' |
	sed -n "${ext_deps_to_cxxflags_sed}" |
	xargs echo -en "\t"
	# print the output file option and the input file
	echo ' -o $@ -c $<'
	echo
	echo "out/${source_file%.cpp}: \\"
	echo -e  "\tout/${source_file%.cpp}.o"
	echo -e  '\t$(CXX) $(MIRROR_LDFLAGS) \\'
	# print the special ldflags for this specific source file
	grep -e "^${source_file}:" < build/common/ext_deps.cache |
	cut -d ':' -f2- | tr ' ' '\n' |
	sed -n "${ext_deps_to_ldflags_sed}" |
	xargs echo -en "\t"
	# print the output file option and the input file
	echo ' -o $@ $<'
	echo
done

# now print the rule for building all input files
for rule in "$(echo ${input_dir} | tr '/' '_')" .IGNORE
do
	find ${input_dir}/ -type f -name '*.cpp' |
	sort |
	sed 's|\(.*\)\.cpp|\\\\\\\n\\\tout/\1.o\\\\\\\n\\\tout/\1|' |
	xargs echo -e "${rule}:"
	echo
done
#
done # while read input_dir
